"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createApalize = void 0;
const apalize_js_1 = require("apalize.js");
let application_id = "";
const createApalize = (config) => {
    application_id = config.application_id;
    return {
        install: (app) => {
            const init_mount = app.mount;
            app.mount = (containerOrSelector) => __awaiter(void 0, void 0, void 0, function* () {
                const apalize = yield (0, apalize_js_1.default)({
                    application_id: "410c740f-2357-4c52-ad8e-2eb4b4b04bf2",
                });
                const translations = convertToVueI18n(apalize.translations);
                Object.keys(translations).forEach(locale => {
                    config.i18n.global.setLocaleMessage(locale, translations[locale]);
                });
                const t = config.i18n.global.t;
                config.i18n.global.t = (key, ...values) => {
                    const translation = t(key, ...values);
                    if (apalize)
                        apalize.translate(key);
                    return translation;
                };
                return init_mount(containerOrSelector);
            });
        }
    };
};
exports.createApalize = createApalize;
const convertToVueI18n = (translations) => {
    const messages = {};
    translations.forEach(translation => {
        const values = translation.values;
        values.forEach(value => {
            if (!messages[value.locale]) {
                messages[value.locale] = {};
            }
            const keys = translation.key.split(".");
            let obj = messages[value.locale];
            for (let i = 0; i < keys.length; i++) {
                if (i === keys.length - 1) {
                    obj[keys[i]] = value.value;
                }
                else {
                    if (!obj[keys[i]]) {
                        obj[keys[i]] = {};
                    }
                    obj = obj[keys[i]];
                }
            }
        });
    });
    return messages;
};
